"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _css() {
  const data = require("@emotion/css");
  _css = function _css() {
    return data;
  };
  return data;
}
function _antd() {
  const data = require("@formily/antd");
  _antd = function _antd() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
function _client2() {
  const data = require("@nocobase/evaluators/client");
  _client2 = function _client2() {
    return data;
  };
  return data;
}
function _client3() {
  const data = require("@nocobase/utils/client");
  _client3 = function _client3() {
    return data;
  };
  return data;
}
function _antd2() {
  const data = require("antd");
  _antd2 = function _antd2() {
    return data;
  };
  return data;
}
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _reactI18next() {
  const data = require("react-i18next");
  _reactI18next = function _reactI18next() {
    return data;
  };
  return data;
}
var _FlowContext = require("../FlowContext");
var _RadioWithTooltip = require("../components/RadioWithTooltip");
var _renderEngineReference = require("../components/renderEngineReference");
var _locale = require("../locale");
var _variable = require("../variable");
var _ValueBlock = require("../components/ValueBlock");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function useDynamicExpressionCollectionFieldMatcher(field) {
  const _useCollectionManager = (0, _client().useCollectionManager)(),
    getCollectionFields = _useCollectionManager.getCollectionFields;
  if (field.type !== 'belongsTo') {
    return false;
  }
  const fields = getCollectionFields(field.target);
  return fields.some(f => f.interface === 'expression');
}
const DynamicConfig = ({
  value,
  onChange: _onChange
}) => {
  const _useTranslation = (0, _reactI18next().useTranslation)(),
    t = _useTranslation.t;
  const scope = (0, _variable.useWorkflowVariableOptions)({
    types: [useDynamicExpressionCollectionFieldMatcher]
  });
  return _react().default.createElement(_antd().FormLayout, {
    layout: "vertical"
  }, _react().default.createElement(_antd().FormItem, {
    colon: true,
    label: t('Expression type', {
      ns: _locale.NAMESPACE
    })
  }, _react().default.createElement(_antd2().Radio.Group, {
    value: value === false ? false : value || null,
    onChange: ev => {
      _onChange(ev.target.value);
    }
  }, _react().default.createElement(_antd2().Radio, {
    value: false
  }, t('Static', {
    ns: _locale.NAMESPACE
  })), _react().default.createElement(_antd2().Radio, {
    value: value || null
  }, t('Dynamic', {
    ns: _locale.NAMESPACE
  })))), value !== false ? _react().default.createElement(_antd().FormItem, {
    label: t('Select dynamic expression', {
      ns: _locale.NAMESPACE
    }),
    extra: t('Select the dynamic expression queried from the upstream node. You need to query it from an expression collection.', {
      ns: _locale.NAMESPACE
    })
  }, _react().default.createElement(_client().Variable.Input, {
    value: value || null,
    onChange: v => _onChange(v),
    scope: scope
  })) : null);
};
function useWorkflowVariableEntityOptions() {
  return (0, _variable.useWorkflowVariableOptions)({
    types: [{
      type: 'reference',
      options: {
        collection: '*',
        entity: true
      }
    }]
  });
}
var _default = {
  title: `{{t("Calculation", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'calculation',
  group: 'control',
  description: `{{t("Calculate an expression based on a calculation engine and obtain a value as the result. Variables in the upstream nodes can be used in the expression. The expression can be static or dynamic one from an expression collections.", { ns: "${_locale.NAMESPACE}" })}}`,
  fieldset: {
    dynamic: {
      type: 'string',
      'x-component': 'DynamicConfig',
      // description: `{{t("Select the dynamic expression queried from the upstream node. You need to query it from an expression collection.", { ns: "${NAMESPACE}" })}}`,
      default: false
    },
    engine: {
      type: 'string',
      title: `{{t("Calculation engine", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'RadioWithTooltip',
      'x-component-props': {
        options: (0, _client2().getOptions)()
      },
      required: true,
      default: 'math.js',
      'x-reactions': {
        dependencies: ['dynamic'],
        fulfill: {
          state: {
            visible: '{{$deps[0] === false}}'
          }
        }
      }
    },
    expression: {
      type: 'string',
      title: `{{t("Calculation expression", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Variable.TextArea',
      'x-component-props': {
        scope: '{{useWorkflowVariableOptions}}'
      },
      ['x-validator'](value, rules, {
        form
      }) {
        const values = form.values;
        const _evaluators$get = _client2().evaluators.get(values.engine),
          evaluate = _evaluators$get.evaluate;
        const exp = value.trim().replace(/{{([^{}]+)}}/g, ' 1 ');
        try {
          evaluate(exp);
          return '';
        } catch (e) {
          return (0, _locale.lang)('Expression syntax error');
        }
      },
      'x-reactions': [{
        dependencies: ['dynamic'],
        fulfill: {
          state: {
            visible: '{{$deps[0] === false}}'
          }
        }
      }, {
        dependencies: ['engine'],
        fulfill: {
          schema: {
            description: '{{renderEngineReference($deps[0])}}'
          }
        }
      }],
      required: true
    },
    scope: {
      type: 'string',
      title: `{{t("Variable datasource", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Variable.Input',
      'x-component-props': {
        scope: '{{useWorkflowVariableEntityOptions}}'
      },
      'x-reactions': {
        dependencies: ['dynamic'],
        fulfill: {
          state: {
            visible: '{{$deps[0] !== false}}'
          }
        }
      }
    }
  },
  view: {},
  scope: {
    useWorkflowVariableOptions: _variable.useWorkflowVariableOptions,
    useWorkflowVariableEntityOptions,
    renderEngineReference: _renderEngineReference.renderEngineReference
  },
  components: {
    CalculationResult({
      dataSource
    }) {
      var _execution$jobs;
      const _useFlowContext = (0, _FlowContext.useFlowContext)(),
        execution = _useFlowContext.execution;
      if (!execution) {
        return (0, _locale.lang)('Calculation result');
      }
      const result = (0, _client3().parse)(dataSource)({
        $jobsMapByNodeId: ((_execution$jobs = execution.jobs) !== null && _execution$jobs !== void 0 ? _execution$jobs : []).reduce((map, job) => Object.assign(map, {
          [job.nodeId]: job.result
        }), {})
      });
      return _react().default.createElement("pre", {
        className: (0, _css().css)`
            margin: 0;
          `
      }, JSON.stringify(result, null, 2));
    },
    RadioWithTooltip: _RadioWithTooltip.RadioWithTooltip,
    DynamicConfig
  },
  useVariables(current, options) {
    const _ref = options !== null && options !== void 0 ? options : {},
      types = _ref.types;
    if (types && !types.some(type => type in _variable.BaseTypeSets || Object.values(_variable.BaseTypeSets).some(set => set.has(type)))) {
      return null;
    }
    return [
      // { key: '', value: '', label: lang('Calculation result') }
    ];
  },
  useInitializers(node) {
    var _node$title;
    return {
      type: 'item',
      title: (_node$title = node.title) !== null && _node$title !== void 0 ? _node$title : `#${node.id}`,
      component: _ValueBlock.ValueBlock.Initializer,
      node,
      resultTitle: (0, _locale.lang)('Calculation result')
    };
  }
};
exports.default = _default;