import React from 'react';
import { ISchema } from '@formily/react';
import { Registry } from '@nocobase/utils/client';
import { SchemaInitializerItemOptions } from '@nocobase/client';
import { VariableOptions } from '../variable';
export interface Instruction {
    title: string;
    type: string;
    group: string;
    description?: string;
    options?: {
        label: string;
        value: any;
        key: string;
    }[];
    fieldset: {
        [key: string]: ISchema;
    };
    view?: ISchema;
    scope?: {
        [key: string]: any;
    };
    components?: {
        [key: string]: any;
    };
    render?(props: any): JSX.Element;
    endding?: boolean;
    useVariables?(node: any, options?: any): VariableOptions;
    useScopeVariables?(node: any, options?: any): VariableOptions;
    useInitializers?(node: any): SchemaInitializerItemOptions | null;
    initializers?: {
        [key: string]: any;
    };
}
export declare const instructions: Registry<Instruction>;
export declare const NodeContext: React.Context<any>;
export declare function useNodeContext(): any;
export declare function useAvailableUpstreams(node: any): any[];
export declare function useUpstreamScopes(node: any): any[];
export declare function Node({ data }: {
    data: any;
}): JSX.Element;
export declare function RemoveButton(): JSX.Element;
export declare function JobButton(): JSX.Element;
export declare function NodeDefaultView(props: any): JSX.Element;
