import React from 'react';
import { ISchema } from '@formily/react';
import { Registry } from '@nocobase/utils/client';
import { SchemaInitializerItemOptions } from '@nocobase/client';
import { VariableOptions } from '../variable';
export interface Trigger {
    title: string;
    type: string;
    useVariables?(config: any, options?: any): VariableOptions;
    fieldset: {
        [key: string]: ISchema;
    };
    view?: ISchema;
    scope?: {
        [key: string]: any;
    };
    components?: {
        [key: string]: any;
    };
    render?(props: any): React.ReactNode;
    useInitializers?(config: any): SchemaInitializerItemOptions | null;
    initializers?: any;
}
export declare const triggers: Registry<Trigger>;
export declare const TriggerConfig: () => JSX.Element;
export declare function useTrigger(): Trigger;
