"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _constants = require("../constants");
const _excluded = ["appends"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
var _default = {
  run(node, input, processor) {
    return _asyncToGenerator(function* () {
      const _node$config = node.config,
        collection = _node$config.collection,
        _node$config$params = _node$config.params,
        _node$config$params2 = _node$config$params === void 0 ? {} : _node$config$params,
        _node$config$params2$ = _node$config$params2.appends,
        appends = _node$config$params2$ === void 0 ? [] : _node$config$params2$,
        params = _objectWithoutProperties(_node$config$params2, _excluded);
      const _node$constructor$dat = node.constructor.database.getCollection(collection),
        repository = _node$constructor$dat.repository,
        model = _node$constructor$dat.model;
      const options = processor.getParsedValue(params, node);
      const result = yield repository.create(_objectSpread(_objectSpread({}, options), {}, {
        context: {
          executionId: processor.execution.id
        },
        transaction: processor.transaction
      }));
      if (result && appends.length) {
        const includeFields = appends.filter(field => !result.get(field) || !result[field]);
        const included = yield model.findByPk(result[model.primaryKeyAttribute], {
          attributes: [model.primaryKeyAttribute],
          include: includeFields,
          transaction: processor.transaction
        });
        includeFields.forEach(field => {
          const value = included.get(field);
          result.set(field, Array.isArray(value) ? value.map(item => item.toJSON()) : value.toJSON(), {
            raw: true
          });
        });
      }
      return {
        // NOTE: get() for non-proxied instance (#380)
        result: result === null || result === void 0 ? void 0 : result.toJSON(),
        status: _constants.JOB_STATUS.RESOLVED
      };
    })();
  }
};
exports.default = _default;