"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _server() {
  const data = require("@nocobase/server");
  _server = function _server() {
    return data;
  };
  return data;
}
const _excluded = ["calculation"];
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function addQuote(v) {
  if (typeof v !== 'string') {
    return v;
  }
  if (v.match(/^{{\s*([^{}]+)\s*}}$/)) {
    return v;
  }
  return `'${v}'`;
}
const calculatorsMap = {
  equal: '==',
  '===': '==',
  notEqual: '!=',
  '!==': '!=',
  gt: '>',
  gte: '>=',
  lt: '<',
  lte: '<=',
  add: '+',
  minus: '-',
  multiple: '*',
  divide: '/',
  mod: '%',
  includes(a, b) {
    return `SEARCH(${b}, ${a}) >= 0`;
  },
  notIncludes(a, b) {
    return `SEARCH(${b}, ${a}) < 0`;
  },
  startsWith(a, b) {
    return `SEARCH(${b}, ${a}) == 0`;
  },
  endsWith(a, b) {
    return `RIGHT(${a}, LEN(${b})) == ${b}`;
  },
  notStartsWith(a, b) {
    return `SEARCH(${b}, ${a}) != 0`;
  },
  notEndsWith(a, b) {
    return `RIGHT(${a}, LEN(${b})) != ${b}`;
  },
  concat(a, b) {
    return `CONCATENATE(${a}, ${b})`;
  }
};
function migrateConfig(_ref = {}) {
  var _calculation$operands, _calculator$operands;
  let calculation = _ref.calculation,
    config = _objectWithoutProperties(_ref, _excluded);
  if (!(calculation === null || calculation === void 0 ? void 0 : calculation.calculator) || !(calculation === null || calculation === void 0 ? void 0 : (_calculation$operands = calculation.operands) === null || _calculation$operands === void 0 ? void 0 : _calculation$operands.length)) {
    return config;
  }
  const calculator = calculatorsMap[calculation.calculator];
  const operands = ((_calculator$operands = calculator.operands) !== null && _calculator$operands !== void 0 ? _calculator$operands : []).map(operand => addQuote(operand));
  return {
    engine: 'formula.js',
    expression: typeof calculator === 'function' ? calculator(...operands) : operands.join(` ${calculator !== null && calculator !== void 0 ? calculator : calculation.calculator} `)
  };
}
class _default extends _server().Migration {
  up() {
    var _this = this;
    return _asyncToGenerator(function* () {
      const match = yield _this.app.version.satisfies('<0.9.0-alpha.3');
      if (!match) {
        return;
      }
      const NodeRepo = _this.context.db.getRepository('flow_nodes');
      yield _this.context.db.sequelize.transaction( /*#__PURE__*/function () {
        var _ref2 = _asyncToGenerator(function* (transaction) {
          const nodes = yield NodeRepo.find({
            filter: {
              type: 'calculation'
            },
            transaction
          });
          console.log('%d nodes need to be migrated.', nodes.length);
          yield nodes.reduce((promise, node) => promise.then(() => {
            return node.update({
              config: migrateConfig(node.config)
            }, {
              transaction
            });
          }), Promise.resolve());
        });
        return function (_x) {
          return _ref2.apply(this, arguments);
        };
      }());
    })();
  }
}
exports.default = _default;